﻿Imports System
Imports System.Collections
Imports System.Collections.Generic
Imports System.Data
Imports System.Data.SqlClient
Imports System.Data.SqlTypes
Imports System.Data.Sql
Imports System.Runtime.InteropServices
Imports Microsoft.SqlServer.Server


Partial Public Class UserDefinedFunctions

    ''' <summary>
    ''' Die Methode lädt Daten aus einer Daten und gibt diese als Ergebnismenge zurück.
    ''' </summary>
    ''' <param name="sFilename"></param>
    ''' <returns>Liste mit PunktInfo Instanzen</returns>

    <Microsoft.SqlServer.Server.SqlFunction(FillRowMethodName:="FillRow", TableDefinition:="Bezeichnung nvarchar(10),Punkt Point")> _
    Public Shared Function LoadFromFile(ByVal sFilename As String) As IEnumerable

        Dim objStreamReader As System.IO.StreamReader
        Dim sInputLine As String
        Dim PunktInput() As String

        Dim list As New List(Of Entities.PunktInfo)()

        If Dir(sFilename.ToString) <> "" Then
            objStreamReader = System.IO.File.OpenText(sFilename)
            sInputLine = objStreamReader.ReadLine()
            Do Until sInputLine Is Nothing
                PunktInput = sInputLine.Split(";"c)
                list.Add(New Entities.PunktInfo(PunktInput(0), Point.Parse(PunktInput(1))))
                sInputLine = objStreamReader.ReadLine()
            Loop
        End If

        Return list

    End Function

    ''' <summary>
    ''' Die Methode wird durch die CLR Runtime aufgerufen um die Daten zurückzugeben
    ''' </summary>
    ''' <param name="obj"></param>
    ''' <param name="bez"></param>
    ''' <param name="pt"></param>

    Public Shared Sub FillRow(ByVal obj As [Object], <Out()> ByRef bez As String, <Out()> ByRef pt As Point)

        Dim objPunkt As Entities.PunktInfo = DirectCast(obj, Entities.PunktInfo)

        bez = objPunkt.Bezeichnung
        pt = objPunkt.Punkt

    End Sub

End Class
