USE [SEK4]
GO

-- Aufrumen
DROP AGGREGATE [dbo].[Concatenate]
GO
DROP ASSEMBLY [CLRSamples]
GO

-- Assembly erstellen wenn notwendig
CREATE ASSEMBLY CLRSamples 
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = SAFE
GO

-- Datentyp erstellen wenn notwendig
CREATE TYPE [dbo].[Point]
EXTERNAL NAME CLRSamples.[CLRSample1.Point]
GO

-- Beispieltabellen
CREATE TABLE [dbo].[Punkt]
(
	[Bezeichnung] [nvarchar](10) NOT NULL,
	[Punkt] [dbo].[Point] NOT NULL
)
GO

-- Datensatz einfgen
INSERT INTO [dbo].[Punkt] ([Bezeichnung],[Punkt])
VALUES ('Testpunkt','123|304')
GO

-- lesen
SELECT Bezeichnung, Punkt  FROM [dbo].[Punkt]
GO

SELECT Bezeichnung, Punkt.ToString() FROM [dbo].[Punkt]
GO

-- ndern zum Ersten
UPDATE [dbo].[Punkt]
SET
	Punkt.X = 1234
GO

SELECT Bezeichnung, Punkt.ToString() FROM [dbo].[Punkt]
GO

-- ndern zum Zweiten
UPDATE [dbo].[Punkt]
SET
	Punkt.X = 1234, Punkt.Y = 3040
GO

-- also
DROP TABLE [dbo].[Punkt]
GO

-- ndern zum Dritten
UPDATE [dbo].[Punkt]
SET
	Punkt.SetValue(1234,3040)
GO

SELECT Bezeichnung, Punkt.ToString() FROM [dbo].[Punkt]
GO
