USE [SEK4]
GO

-- Aufrumen (mal wieder)
DROP TABLE [dbo].[Punkt]
GO
DROP AGGREGATE [dbo].[Concatenate]
GO
DROP ASSEMBLY [CLRSamples]
GO

-- wenn notwendig
CREATE ASSEMBLY CLRSamples 
FROM 'C:\Workshops\SEK4\CLRSample1\CLRSample1\bin\CLRSample1.dll'
WITH PERMISSION_SET = UNSAFE
GO

-- und die Funktion definieren
CREATE FUNCTION [dbo].[LoadFromFile](@sFilename [nvarchar](4000))
RETURNS  TABLE (
	[Bezeichnung] [nvarchar](10) NULL,
	[Punkt] [dbo].[Point] NULL
) WITH EXECUTE AS CALLER
AS 
EXTERNAL NAME CLRSample1.[CLRSample1.UserDefinedFunctions].[LoadFromFile]
GO

-- Tabelle anlegen
CREATE TABLE [dbo].[Punkt]
(
	[Bezeichnung] [nvarchar](10) NOT NULL,
	[Punkt] [dbo].[Point] NOT NULL
)
GO

-- ein paar Datenstze aus einer Textdatei einlesen
INSERT INTO [dbo].[Punkt] SELECT * FROM LoadFromFile('C:\Workshops\SEK4\Punkte7.txt')

-- Anzeigen
SELECT Bezeichnung, Punkt.ToString()  FROM [dbo].[Punkt]
GO
